<template>
  <div class="wrapper">
    <div class="container">
      <div class="filter">
        <div class="strategies"></div>
        <div class="categories">
          <div class="filter-selected" @click="show = !show">
            <span class="filter-selected-name">{{
              $t(`restaurantTypes.${category}`)
            }}</span>
            <i class="ic-sm-arrow" :style="iconStyle"></i>
          </div>
        </div>
      </div>
    </div>
    <category-filter
      :show="show"
      :category="category"
      @changed="changeCategory"
    />
  </div>
</template>

<script>
import BScroll from "better-scroll";
import CategoryFilter from "./CategoryFilter";
import wheel from "@/lib/better-scroll-vertical-wheel";

export default {
  props: {
    selectedStrategy: {
      type: String
    },
    strategies: {
      type: Array,
      required: true
    },
    category: {
      type: String,
      required: true
    }
  },

  components: {
    CategoryFilter
  },

  data() {
    return {
      dragging: false,
      show: false
    };
  },

  methods: {
    selectStrategy(strategy) {
      this.$emit("changed", {
        strategy,
        category: this.category
      });
    },

    changeCategory(category) {
      this.show = false;
      this.$emit("changed", {
        strategy: this.strategies.find(s => s.key === this.selectedStrategy),
        category
      });
    },

    iconStyle() {
      return {
        transform: `rotateZ(${this.show ? "180" : "0"}deg)`
      };
    }
  }
};
</script>

<style lang="scss" scoped>
.wrapper {
  background: $color-white;
  box-shadow: 0 6px 12px rgba(0, 0, 0, 0.03);
  position: relative;
  z-index: 1;
  font-size: 14px;
}

.wrapper .container {
  @include media-breakpoint-down(sm) {
    padding: 0;
  }
}

.filter {
  display: flex;
  position: relative;
  left: -10px;
  right: 0;
}

.strategies {
  flex: 1;
  position: relative;
  line-height: 46px;
  overflow: hidden;
  user-select: none;

  &::after {
    content: "";
    position: absolute;
    right: 0;
    top: 0;
    display: block;
    width: 84px;
    height: 100%;
    background-image: linear-gradient(
      to right,
      rgba(255, 255, 255, 0),
      #ffffff
    );
    pointer-events: none;
  }
}

.strategy-list {
  display: inline-block;
  white-space: nowrap;
  cursor: grab;

  &.dragging {
    cursor: grabbing;
  }
}

.strategy {
  position: relative;
  display: inline-block;
  padding: 0 10px;
  margin: 0 10px;
  cursor: pointer;

  &.selected {
    color: $color-skm-red;
  }

  &.selected::after {
    content: "";
    position: absolute;
    left: 0;
    bottom: 0;
    width: 100%;
    height: 3px;
    background: $color-skm-red;
  }
}

.categories {
  white-space: nowrap;
  padding: 0 35px;
  border-left: 1px solid #cad1dd;
  line-height: 46px;
  height: 46px;

  @include media-breakpoint-down(sm) {
    padding: 0 13.3px;
  }
}

.filter-selected {
  user-select: none;
  cursor: pointer;
}

.ic-sm-arrow {
  font-size: 9.84px;
  display: inline-block;
  vertical-align: middle;
}
</style>
